proc_lib = "Demo"
Createlib proc_lib
; ---------------------------------------------------------------------------
; ================================= VolHoursSummary() =============================
; ---------------------------------------------------------------------------
Proc VolHoursSummary()
  private ret,procname,
              month.s,
              bgnmon.s,
              firstmon.d,
              lastmon.d,
              year.a  ;yearly range used for report
  procname = "VolHoursSummary"
 rtnmsg = ""
 ; this step brings up form for user to fill in month for selection of report
 CoEdit "QBFV" PickForm 2 Ins
 [Report Name]="Volunteer hours summary"
 ;default Month to current month
 [month num] = 100*(Year(Today())-1900) + Month(Today())
 Prompt "F2 - Begin Printing                                                  Esc - Abort",""
 ;wait for user to fill in form and Press F2
  While true
    Wait record
      Message rtnmsg
      Until "F2","Esc"
    RtnMsg="" error.fld=""
    If retval = "Esc" Then Quitloop
      Else Quitloop
    Endif
 Endwhile
  prg.n = [Program #]
  If IsBlank([Month num]) Then
    [month num] = 100*(Year(Today())-1900) + Month(Today())
  Endif
  month.s = [Month num]
 Del Do_It!
 Clearall
 Prompt   ;Clear Prompt
 Clearall
 If retval = "Esc" Then Return false Endif
 ;give user a message so they don't get impatience
 DotsBlink("Selecting records for Volunteer hours summary")
  ;user enterd last month on form
  ;get first day of last month
   lastmon.d = Dateval(Substr(month.s,3,2)+"/1/"+Substr(month.s,1,2))
  ;convert to last day of last month
   lastmon.d = lastmon.d + 40 -(Day(lastmon.d + 40)) ;get last day of month
  ;find month number of 1st month
   bgnmon.s = month.s -100 +1
  ;If year spans December then correct to new year
  If Mod(bgnmon.s,100) = 13 Then
    bgnmon.s = bgnmon.s +100 -12
  Endif
  ;find first day of first month
  firstmon.d = Dateval(Substr(bgnmon.s,3,2)+"/1/"+Substr(bgnmon.s,1,2))
  Clearall
  {Ask} Select "VHours" CheckPlus
     MoveTo [Program #]
     Typein Strval(prg.n)  ;If a single program was selected
     [Vol id]    = "_id"
   ;enter date range for year selected
   Moveto [Date] Typein ">= "+Strval(firstmon.d)+", <="+Strval(lastmon.d)
  Do_It!
  If IsEmpty("Answer") Then
    rtnMsg = "No record found meeting your selection criteria"
    Return false
  Endif
  ;Set this variables for use in the Report
  year.a = Strval(firstmon.d)+" - "+Strval(lastmon.d)
  Rename "Answer" "Entry"  ;to keep this table around
  ;Convert the date fields in the Table to a range of months
  ConvertDateNum(bgnmon.s,month.s,"Entry","Date")
  Array monthtitle.r[12]   ;Create array for Titles of month columns
  CoEditKey ; Edit Answer table
;this loop will insert one value for each month at the top of the table
;it will insure that there are a full 12 months in the table to be
;Crosstabed and it will controle the order of column fields in the
;Crosstab table
  For cntr from 0 to 11   ;Enter one entry for every month
   Ins
   [Month] = bgnmon.s + cntr ;insert a value for each of the 12 months
    If Mod([month],100) >= 13 Then
      [month] = [month] +100 -12
    Endif
    ;convert each month to date value for 1st of month
    x = Substr([Month],3,2)+"/1/90"
    ;this will become a column head in the report
    monthtitle.r[cntr+1] = Moy(Dateval(x))+Substr([Month],1,2)
   LockRecord UnlockRecord  ;Post record
  Endfor
  Do_It!
    Moveto [Vol Id]
    Rotate Rotate Rotate  ;This line for demo only
    Moveto [Vol Id] Menu {Image} {Graph} {CrossTab}
    Select "1) Sum"
    Moveto [Vol Id]    Enter
    Moveto [Month] Enter
    Moveto [Hours] Enter
    Create "Entry" Like  "_Vxtab" ;_Vxtab holds the report specification
    Add "Crosstab" "Entry"
    CopyReport "_Vxtab"  "1"  "Entry" "R"  ;copy to R to modify
 ;Now modify the report to place column labels
    {Report}{Change}  Select "Entry"
    Select "R" Enter
    Down Down
    Down Down
    Down
    Typein "NAME"+Spaces(18)+"Term"
    For cntr From 1 to 12
      Typein monthtitle.r[cntr] + ""
    Endfor
    Do_It!
    Report "Entry" "R"
 Clearall
EndProc
Writelib proc_lib VolHoursSummary
Release Procs VolHoursSummary
?? ". "
; ---------------------------------------------------------------------------
; ================================= ConvertDateNum() =============================
; ---------------------------------------------------------------------------
Proc ConvertDateNum(bgnmon.s,endmon.s,table.a,field.nm)
  ;bgnmon.s   beginning Month number in from YYMM
  ;endmon.s   ending Month Number
  ;table.a    is table with dates to be converted to months
  ;field.nm   is field with date
  private ret,procname,
              cntr,
              months.n,  ;number of months
              currmon.s  ;number of the current month
  procname = "ConvertDateNum"
  ClearAll  ;Get clean WorkSpace
  ;Create a Monthly Range table and fill it in
  Create "Entry000"     ;create this temporary table
     "Begin Date":"D",
     "End Date"  :"D",
     "Month"     :"S"
 ;calculate number of months to convert
 ;first by difference in years
  months.n = 1 + ((Int(endmon.s/100) - Int(bgnmon.s/100)) * 12) ;differenc in years
 ;then by difference in months
  months.n = months.n + (Mod(endmon.s,100)-Mod(bgnmon.s,100))   ;difference in months
 ;set current month to beginning month
  currmon.s = bgnmon.s
  CoEdit "Entry000"
  For cntr from 1 to months.n
    Ins         ;New record
    ;enter first day of month
    [Begin Date] =  Dateval(Substr(currmon.s,3,2)+"/1/"+Substr(currmon.s,1,2))
    ;enter last day of month
    [End Date] =   [Begin Date] + 40 -(Day([Begin Date]+40))
    [Month] = currmon.s
    ;reset current month
    currmon.s =   (100*(Year([end Date]+1)-1900)) + Month([End Date]+1) ;advance month number
  EndFor
  Do_it!
  ;join to range table and sum value fields by month
  Clearall
  {Ask} Select  table.a ;table to be converted
      Checkplus                    ;checkplus all fields when in [#]
      Moveto Field field.nm        ;value field to be summed
      Check   ;uncheck this field  do not include in answer
      [] = ">= _bgn, <= _end"
   {Ask} Select  "Entry000"
      [Begin Date] = "_bgn"
      [End Date] = "_end"
      Moveto  [Month]  Check       ;include this field in "Answer"
   Do_It!
EndProc
Writelib proc_lib ConvertDateNum
Release Procs ConvertDateNum
?? ". "
;============================================================================
;=======================   Procedure Dotsblink      =========================
;============================================================================
  Proc Dotsblink(msg)
  Private ret
  @ 22,0 Clear Eol  ;clear this line
  @ 22,70-Len(msg) Style Reverse ??msg  Style Reverse,Blink ??" . . . . ."
  Style             ;Reset Style
  EndProc
  Writelib proc_lib Dotsblink
  Release Procs  Dotsblink
